export Box, Box1d, Box2d, Box3d


struct Box{N_Dim}
  extends::NTuple{N_Dim,NTuple{2,Float64}}
  function Box{N_Dim}(extends::Vararg{NTuple{2,Float64},N_Dim}) where N_Dim
    widths = [ r-l for (l,r) in extends ]
    @assert all(widths .> 0) "'extends' must be ordered tuples."
    new{N_Dim}(extends)
  end
end
const Box1d = Box{1}
const Box2d = Box{2}
const Box3d = Box{3}


Base.getindex(b::Box, idx::Int) = b.extends[idx]


function Base.show(io::IO, b::Box1d)
  xmin, xmax = b.extends[1]
  print("""
        $(typeof(b))
          dimension     = 1
          (xmin, xmax)  = ($xmin, $xmax)
        """)
end
function Base.show(io::IO, b::Box2d)
  xmin, xmax = b.extends[1]
  ymin, ymax = b.extends[2]
  print("""
        $(typeof(b))
          dimension     = 2
          (xmin, xmax)  = ($xmin, $xmax)
          (ymin, ymax)  = ($ymin, $ymax)
        """)
end
function Base.show(io::IO, b::Box3d)
  xmin, xmax = b.extends[1]
  ymin, ymax = b.extends[2]
  zmin, zmax = b.extends[3]
  print("""
        $(typeof(b))
          dimension     = 1
          (xmin, xmax)  = ($xmin, $xmax)
          (ymin, ymax)  = ($ymin, $ymax)
          (zmin, zmax)  = ($zmin, $zmax)
        """)
end
