#######################################################################
#                                Types                                #
#######################################################################


"""
    AbstractTCI

Supertype for TroubledCellIndicator interface.
"""
abstract type AbstractTCI end


#######################################################################
#                              Interface                              #
#######################################################################


#######################################################################
#                               Methods                               #
#######################################################################


function make_TCI(parameters, mesh::Mesh)
  type = Symbol(get(parameters, "type", missing))
  concretes = [ Base.typename(ct).name for ct in concretetypes(AbstractTCI) ]
  if type === :missing
    return nothing
  end
  @assert type in concretes "TCI parameter 'type = $type' unknown. Available options: $concretes"
  tci_type = eval(type)
  tci_prms = parse_parameters(tci_type, parameters)
  return tci_type(; mesh, tci_prms...)
end
